/* -*- c++ -*-
Copyright  1993 Bengt Mrtensson and Institute for Dynamical Systems.

This file is part of Gnans.

Gnans is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

Gnans is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Gnans; see the file COPYING.  If not, write to the 
Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

// $Id: Store.h,v 1.3 1994/01/12 22:58:26 bengt Exp $

#ifndef _Store_h
#define _Store_h

#ifdef __GNUG__
#pragma interface
#endif

#include <string>
#include <stdio.h>		// For FILE

// Data structure for user variable to be stored 
class Store {
  // How large is the discontinuity table presently?
  static unsigned int discontinuity_table_size;

  // A vector containing all index of discontinuety...
  static unsigned int *discontinuities;

  static unsigned int no_of_discontinuities;
  
public:
  static void add_discontinuity();
  static void reset_discontinuities();
  static unsigned int get_no_of_trajectories();
  static const unsigned int *get_discontinuities();

  // FILE variable for this variable
  static FILE *file; 

  // File name for this variable
  static std::string filename;

  // The Gnans name of the varible 
  std::string name;
  
  // Pointer to the value 
  double *ptr;

  // Pointer to its trajectory (= large array) 
  double *trajectory; 
};

#endif
